<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<meta name="robots" content="NOINDEX, NOFOLLOW" /> <!-- Prevent indexing by search engines -->
<title>ARM Compute Library: src/core/CL/cl_kernels/transpose.cl File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" src="http://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">ARM Compute Library
   &#160;<span id="projectnumber">17.04</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.xhtml"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.xhtml"><span>Namespaces</span></a></li>
      <li><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.xhtml"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.xhtml"><span>File&#160;List</span></a></li>
      <li><a href="globals.xhtml"><span>Globals</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('transpose_8cl.xhtml','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">transpose.cl File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;<a class="el" href="helpers_8h_source.xhtml">helpers.h</a>&quot;</code><br />
</div>
<p><a href="transpose_8cl_source.xhtml">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:a53bd970b471b909bef8456b6b564f35e"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">SWAP_ROW</a>(u0,  l0)</td></tr>
<tr class="separator:a53bd970b471b909bef8456b6b564f35e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af5dc9980a3e0aae2cba22e97b9458bc9"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="transpose_8cl.xhtml#af5dc9980a3e0aae2cba22e97b9458bc9">SWAP_4x4</a>(u0,  u1,  u2,  u3,  l0,  l1,  l2,  l3)</td></tr>
<tr class="separator:af5dc9980a3e0aae2cba22e97b9458bc9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a91074bda470bd8bec36799fdaffd107a"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="transpose_8cl.xhtml#a91074bda470bd8bec36799fdaffd107a">SWAP_8x8</a>(u0,  u1,  u2,  u3,  u4,  u5,  u6,  u7,  l0,  l1,  l2,  l3,  l4,  l5,  l6,  l7)</td></tr>
<tr class="separator:a91074bda470bd8bec36799fdaffd107a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a093adbe8897f56bc8d0998f5cad57c8a"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="transpose_8cl.xhtml#a093adbe8897f56bc8d0998f5cad57c8a">TRANSPOSE_4x4</a>(u0,  u1,  u2,  u3)</td></tr>
<tr class="separator:a093adbe8897f56bc8d0998f5cad57c8a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad037a4e8ddc84de9c0512a2d4ee693bf"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="transpose_8cl.xhtml#ad037a4e8ddc84de9c0512a2d4ee693bf">TRANSPOSE_8x8</a>(u0,  u1,  u2,  u3,  u4,  u5,  u6,  u7)</td></tr>
<tr class="separator:ad037a4e8ddc84de9c0512a2d4ee693bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae6c2b1bad97366395ba7a9a688533ff4"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="transpose_8cl.xhtml#ae6c2b1bad97366395ba7a9a688533ff4">TRANSPOSE_16x16</a>(u0,  u1,  u2,  u3,  u4,  u5,  u6,  u7,  u8,  u9,  u10,  u11,  u12,  u13,  u14,  u15)</td></tr>
<tr class="separator:ae6c2b1bad97366395ba7a9a688533ff4"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:aa9021e9b8c37ea94257627da631248db"><td class="memItemLeft" align="right" valign="top">__kernel void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="transpose_8cl.xhtml#aa9021e9b8c37ea94257627da631248db">transpose</a> (__global uchar *src_ptr, uint src_stride_x, uint src_step_x, uint src_stride_y, uint src_step_y, uint src_offset_first_element_in_bytes, __global uchar *dst_ptr, uint dst_stride_x, uint dst_step_x, uint dst_stride_y, uint dst_step_y, uint dst_offset_first_element_in_bytes)</td></tr>
<tr class="memdesc:aa9021e9b8c37ea94257627da631248db"><td class="mdescLeft">&#160;</td><td class="mdescRight">This OpenCL kernel computes the matrix transposition of input matrix.  <a href="#aa9021e9b8c37ea94257627da631248db">More...</a><br /></td></tr>
<tr class="separator:aa9021e9b8c37ea94257627da631248db"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a class="anchor" id="af5dc9980a3e0aae2cba22e97b9458bc9"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define SWAP_4x4</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u0, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u1, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u2, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u3, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">l0, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">l1, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">l2, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">l3&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line">({                                           <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">\</a></div><div class="line"><a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">        VEC_DATA_TYPE</a>(<a class="code" href="convolution3x3_8cl.xhtml#afb8c72ce35c4a1f4a2588d6573e54aa1">DATA_TYPE</a>, 4)              \</div><div class="line">        tmp_swap;                                <a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">        SWAP_ROW</a>(u0, l0);                        <a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">        SWAP_ROW</a>(u1, l1);                        <a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">        SWAP_ROW</a>(u2, l2);                        <a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">        SWAP_ROW</a>(u3, l3);                        \</div><div class="line">    })</div><div class="ttc" id="convolution3x3_8cl_xhtml_afb8c72ce35c4a1f4a2588d6573e54aa1"><div class="ttname"><a href="convolution3x3_8cl.xhtml#afb8c72ce35c4a1f4a2588d6573e54aa1">DATA_TYPE</a></div><div class="ttdeci">#define DATA_TYPE</div><div class="ttdef"><b>Definition:</b> <a href="convolution3x3_8cl_source.xhtml#l00027">convolution3x3.cl:27</a></div></div>
<div class="ttc" id="transpose_8cl_xhtml_a53bd970b471b909bef8456b6b564f35e"><div class="ttname"><a href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">SWAP_ROW</a></div><div class="ttdeci">#define SWAP_ROW(u0, l0)</div><div class="ttdef"><b>Definition:</b> <a href="transpose_8cl_source.xhtml#l00026">transpose.cl:26</a></div></div>
<div class="ttc" id="helpers_8h_xhtml_a36f754c05b6fddf6df0d8d0a74f8159f"><div class="ttname"><a href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a></div><div class="ttdeci">#define VEC_DATA_TYPE(type, size)</div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00032">helpers.h:32</a></div></div>
</div><!-- fragment -->
<p>Definition at line <a class="el" href="transpose_8cl_source.xhtml#l00033">33</a> of file <a class="el" href="transpose_8cl_source.xhtml">transpose.cl</a>.</p>

</div>
</div>
<a class="anchor" id="a91074bda470bd8bec36799fdaffd107a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define SWAP_8x8</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u0, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u1, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u2, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u3, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u4, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u5, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u6, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u7, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">l0, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">l1, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">l2, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">l3, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">l4, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">l5, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">l6, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">l7&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line">({                                                                           <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">\</a></div><div class="line"><a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">        VEC_DATA_TYPE</a>(<a class="code" href="convolution3x3_8cl.xhtml#afb8c72ce35c4a1f4a2588d6573e54aa1">DATA_TYPE</a>, 8)                                              \</div><div class="line">        tmp_swap;                                                                <a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">        SWAP_ROW</a>(u0, l0);                                                        <a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">        SWAP_ROW</a>(u1, l1);                                                        <a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">        SWAP_ROW</a>(u2, l2);                                                        <a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">        SWAP_ROW</a>(u3, l3);                                                        <a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">        SWAP_ROW</a>(u4, l4);                                                        <a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">        SWAP_ROW</a>(u5, l5);                                                        <a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">        SWAP_ROW</a>(u6, l6);                                                        <a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">        SWAP_ROW</a>(u7, l7);                                                        \</div><div class="line">    })</div><div class="ttc" id="convolution3x3_8cl_xhtml_afb8c72ce35c4a1f4a2588d6573e54aa1"><div class="ttname"><a href="convolution3x3_8cl.xhtml#afb8c72ce35c4a1f4a2588d6573e54aa1">DATA_TYPE</a></div><div class="ttdeci">#define DATA_TYPE</div><div class="ttdef"><b>Definition:</b> <a href="convolution3x3_8cl_source.xhtml#l00027">convolution3x3.cl:27</a></div></div>
<div class="ttc" id="transpose_8cl_xhtml_a53bd970b471b909bef8456b6b564f35e"><div class="ttname"><a href="transpose_8cl.xhtml#a53bd970b471b909bef8456b6b564f35e">SWAP_ROW</a></div><div class="ttdeci">#define SWAP_ROW(u0, l0)</div><div class="ttdef"><b>Definition:</b> <a href="transpose_8cl_source.xhtml#l00026">transpose.cl:26</a></div></div>
<div class="ttc" id="helpers_8h_xhtml_a36f754c05b6fddf6df0d8d0a74f8159f"><div class="ttname"><a href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a></div><div class="ttdeci">#define VEC_DATA_TYPE(type, size)</div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00032">helpers.h:32</a></div></div>
</div><!-- fragment -->
<p>Definition at line <a class="el" href="transpose_8cl_source.xhtml#l00043">43</a> of file <a class="el" href="transpose_8cl_source.xhtml">transpose.cl</a>.</p>

</div>
</div>
<a class="anchor" id="a53bd970b471b909bef8456b6b564f35e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define SWAP_ROW</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u0, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">l0&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line">({                       \</div><div class="line">        tmp_swap = u0;       \</div><div class="line">        u0       = l0;       \</div><div class="line">        l0       = tmp_swap; \</div><div class="line">    })</div></div><!-- fragment -->
<p>Definition at line <a class="el" href="transpose_8cl_source.xhtml#l00026">26</a> of file <a class="el" href="transpose_8cl_source.xhtml">transpose.cl</a>.</p>

</div>
</div>
<a class="anchor" id="ae6c2b1bad97366395ba7a9a688533ff4"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define TRANSPOSE_16x16</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u0, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u1, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u2, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u3, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u4, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u5, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u6, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u7, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u8, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u9, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u10, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u11, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u12, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u13, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u14, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u15&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line">({                                                                                                                                       <a class="code" href="transpose_8cl.xhtml#ad037a4e8ddc84de9c0512a2d4ee693bf">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#ad037a4e8ddc84de9c0512a2d4ee693bf">        TRANSPOSE_8x8</a>(u0.s01234567, u1.s01234567, u2.s01234567, u3.s01234567, u4.s01234567, u5.s01234567, u6.s01234567, u7.s01234567);       <a class="code" href="transpose_8cl.xhtml#ad037a4e8ddc84de9c0512a2d4ee693bf">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#ad037a4e8ddc84de9c0512a2d4ee693bf">        TRANSPOSE_8x8</a>(u0.s89ABCDEF, u1.s89ABCDEF, u2.s89ABCDEF, u3.s89ABCDEF, u4.s89ABCDEF, u5.s89ABCDEF, u6.s89ABCDEF, u7.s89ABCDEF);       <a class="code" href="transpose_8cl.xhtml#ad037a4e8ddc84de9c0512a2d4ee693bf">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#ad037a4e8ddc84de9c0512a2d4ee693bf">        TRANSPOSE_8x8</a>(u8.s01234567, u9.s01234567, u10.s01234567, u11.s01234567, u12.s01234567, u13.s01234567, u14.s01234567, u15.s01234567); <a class="code" href="transpose_8cl.xhtml#ad037a4e8ddc84de9c0512a2d4ee693bf">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#ad037a4e8ddc84de9c0512a2d4ee693bf">        TRANSPOSE_8x8</a>(u8.s89ABCDEF, u9.s89ABCDEF, u10.s89ABCDEF, u11.s89ABCDEF, u12.s89ABCDEF, u13.s89ABCDEF, u14.s89ABCDEF, u15.s89ABCDEF); <a class="code" href="transpose_8cl.xhtml#a91074bda470bd8bec36799fdaffd107a">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a91074bda470bd8bec36799fdaffd107a">        SWAP_8x8</a>(u0.s89ABCDEF, u1.s89ABCDEF, u2.s89ABCDEF, u3.s89ABCDEF, u4.s89ABCDEF, u5.s89ABCDEF, u6.s89ABCDEF, u7.s89ABCDEF,             \</div><div class="line">                 u8.s01234567, u9.s01234567, u10.s01234567, u11.s01234567, u12.s01234567, u13.s01234567, u14.s01234567, u15.s01234567);      \</div><div class="line">    })</div><div class="ttc" id="transpose_8cl_xhtml_a91074bda470bd8bec36799fdaffd107a"><div class="ttname"><a href="transpose_8cl.xhtml#a91074bda470bd8bec36799fdaffd107a">SWAP_8x8</a></div><div class="ttdeci">#define SWAP_8x8(u0, u1, u2, u3, u4, u5, u6, u7, l0, l1, l2, l3, l4, l5, l6, l7)</div><div class="ttdef"><b>Definition:</b> <a href="transpose_8cl_source.xhtml#l00043">transpose.cl:43</a></div></div>
<div class="ttc" id="transpose_8cl_xhtml_ad037a4e8ddc84de9c0512a2d4ee693bf"><div class="ttname"><a href="transpose_8cl.xhtml#ad037a4e8ddc84de9c0512a2d4ee693bf">TRANSPOSE_8x8</a></div><div class="ttdeci">#define TRANSPOSE_8x8(u0, u1, u2, u3, u4, u5, u6, u7)</div><div class="ttdef"><b>Definition:</b> <a href="transpose_8cl_source.xhtml#l00080">transpose.cl:80</a></div></div>
</div><!-- fragment -->
<p>Definition at line <a class="el" href="transpose_8cl_source.xhtml#l00089">89</a> of file <a class="el" href="transpose_8cl_source.xhtml">transpose.cl</a>.</p>

</div>
</div>
<a class="anchor" id="a093adbe8897f56bc8d0998f5cad57c8a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define TRANSPOSE_4x4</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u0, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u1, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u2, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u3&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line">({                                <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">\</a></div><div class="line"><a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">        VEC_DATA_TYPE</a>(<a class="code" href="convolution3x3_8cl.xhtml#afb8c72ce35c4a1f4a2588d6573e54aa1">DATA_TYPE</a>, 4)   \</div><div class="line">        tmp;                          \</div><div class="line">        tmp.s012 = u0.s123;           \</div><div class="line">        u0.s1    = u1.s0;             \</div><div class="line">        u0.s2    = u2.s0;             \</div><div class="line">        u0.s3    = u3.s0;             \</div><div class="line">        u1.s0    = tmp.s0;            \</div><div class="line">        u2.s0    = tmp.s1;            \</div><div class="line">        u3.s0    = tmp.s2;            \</div><div class="line">        \</div><div class="line">        tmp.s01 = u1.s23;             \</div><div class="line">        u1.s2   = u2.s1;              \</div><div class="line">        u1.s3   = u3.s1;              \</div><div class="line">        u2.s1   = tmp.s0;             \</div><div class="line">        u3.s1   = tmp.s1;             \</div><div class="line">        \</div><div class="line">        tmp.s0 = u2.s3;               \</div><div class="line">        u2.s3  = u3.s2;               \</div><div class="line">        u3.s2  = tmp.s0;              \</div><div class="line">    })</div><div class="ttc" id="convolution3x3_8cl_xhtml_afb8c72ce35c4a1f4a2588d6573e54aa1"><div class="ttname"><a href="convolution3x3_8cl.xhtml#afb8c72ce35c4a1f4a2588d6573e54aa1">DATA_TYPE</a></div><div class="ttdeci">#define DATA_TYPE</div><div class="ttdef"><b>Definition:</b> <a href="convolution3x3_8cl_source.xhtml#l00027">convolution3x3.cl:27</a></div></div>
<div class="ttc" id="helpers_8h_xhtml_a36f754c05b6fddf6df0d8d0a74f8159f"><div class="ttname"><a href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a></div><div class="ttdeci">#define VEC_DATA_TYPE(type, size)</div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00032">helpers.h:32</a></div></div>
</div><!-- fragment -->
<p>Definition at line <a class="el" href="transpose_8cl_source.xhtml#l00057">57</a> of file <a class="el" href="transpose_8cl_source.xhtml">transpose.cl</a>.</p>

</div>
</div>
<a class="anchor" id="ad037a4e8ddc84de9c0512a2d4ee693bf"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define TRANSPOSE_8x8</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u0, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u1, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u2, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u3, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u4, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u5, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u6, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">u7&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Value:</b><div class="fragment"><div class="line">({                                                                                            <a class="code" href="transpose_8cl.xhtml#a093adbe8897f56bc8d0998f5cad57c8a">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a093adbe8897f56bc8d0998f5cad57c8a">        TRANSPOSE_4x4</a>(u0.s0123, u1.s0123, u2.s0123, u3.s0123);                                    <a class="code" href="transpose_8cl.xhtml#a093adbe8897f56bc8d0998f5cad57c8a">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a093adbe8897f56bc8d0998f5cad57c8a">        TRANSPOSE_4x4</a>(u0.s4567, u1.s4567, u2.s4567, u3.s4567);                                    <a class="code" href="transpose_8cl.xhtml#a093adbe8897f56bc8d0998f5cad57c8a">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a093adbe8897f56bc8d0998f5cad57c8a">        TRANSPOSE_4x4</a>(u4.s0123, u5.s0123, u6.s0123, u7.s0123);                                    <a class="code" href="transpose_8cl.xhtml#a093adbe8897f56bc8d0998f5cad57c8a">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#a093adbe8897f56bc8d0998f5cad57c8a">        TRANSPOSE_4x4</a>(u4.s4567, u5.s4567, u6.s4567, u7.s4567);                                    <a class="code" href="transpose_8cl.xhtml#af5dc9980a3e0aae2cba22e97b9458bc9">\</a></div><div class="line"><a class="code" href="transpose_8cl.xhtml#af5dc9980a3e0aae2cba22e97b9458bc9">        SWAP_4x4</a>(u0.s4567, u1.s4567, u2.s4567, u3.s4567, u4.s0123, u5.s0123, u6.s0123, u7.s0123); \</div><div class="line">    })</div><div class="ttc" id="transpose_8cl_xhtml_a093adbe8897f56bc8d0998f5cad57c8a"><div class="ttname"><a href="transpose_8cl.xhtml#a093adbe8897f56bc8d0998f5cad57c8a">TRANSPOSE_4x4</a></div><div class="ttdeci">#define TRANSPOSE_4x4(u0, u1, u2, u3)</div><div class="ttdef"><b>Definition:</b> <a href="transpose_8cl_source.xhtml#l00057">transpose.cl:57</a></div></div>
<div class="ttc" id="transpose_8cl_xhtml_af5dc9980a3e0aae2cba22e97b9458bc9"><div class="ttname"><a href="transpose_8cl.xhtml#af5dc9980a3e0aae2cba22e97b9458bc9">SWAP_4x4</a></div><div class="ttdeci">#define SWAP_4x4(u0, u1, u2, u3, l0, l1, l2, l3)</div><div class="ttdef"><b>Definition:</b> <a href="transpose_8cl_source.xhtml#l00033">transpose.cl:33</a></div></div>
</div><!-- fragment -->
<p>Definition at line <a class="el" href="transpose_8cl_source.xhtml#l00080">80</a> of file <a class="el" href="transpose_8cl_source.xhtml">transpose.cl</a>.</p>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="aa9021e9b8c37ea94257627da631248db"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">__kernel void transpose </td>
          <td>(</td>
          <td class="paramtype">__global uchar *&#160;</td>
          <td class="paramname"><em>src_ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint&#160;</td>
          <td class="paramname"><em>src_stride_x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint&#160;</td>
          <td class="paramname"><em>src_step_x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint&#160;</td>
          <td class="paramname"><em>src_stride_y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint&#160;</td>
          <td class="paramname"><em>src_step_y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint&#160;</td>
          <td class="paramname"><em>src_offset_first_element_in_bytes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">__global uchar *&#160;</td>
          <td class="paramname"><em>dst_ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint&#160;</td>
          <td class="paramname"><em>dst_stride_x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint&#160;</td>
          <td class="paramname"><em>dst_step_x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint&#160;</td>
          <td class="paramname"><em>dst_stride_y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint&#160;</td>
          <td class="paramname"><em>dst_step_y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint&#160;</td>
          <td class="paramname"><em>dst_offset_first_element_in_bytes</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This OpenCL kernel computes the matrix transposition of input matrix. </p>
<dl class="section attention"><dt>Attention</dt><dd>The number of bytes of the data type need to be passed at compile time using -DDATA_TYPE_IN_BYTES. DATA_TYPE_IN_BYTES can be:<ol type="1">
<li>-DDATA_TYPE_IN_BYTES=1 for transposing U8 or S8 matrices</li>
<li>-DDATA_TYPE_IN_BYTES=2 for transposing U16, S16 or FP16 matrices</li>
<li>-DDATA_TYPE_IN_BYTES=4 for transposing U32, S32 or FP32 matrices</li>
</ol>
</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">src_ptr</td><td>Pointer to the source matrix. Supported data types: U8/S8/U16/S16/F16/U32/S32/F32 </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src_stride_x</td><td>Stride of the source matrix in X dimension (in bytes) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src_step_x</td><td>src_stride_x * number of elements along X processed per workitem(in bytes) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src_stride_y</td><td>Stride of the source matrix in Y dimension (in bytes) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src_step_y</td><td>src_stride_y * number of elements along Y processed per workitem(in bytes) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">src_offset_first_element_in_bytes</td><td>The offset of the first element in the source matrix </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">dst_ptr</td><td>Pointer to the destination matrix Supported data type: same as src_ptr </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst_stride_x</td><td>Stride of the destination matrix in X dimension (in bytes) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst_step_x</td><td>dst_gx_stride_x * number of elements along X processed per workitem(in bytes) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst_stride_y</td><td>Stride of the destination matrix in Y dimension (in bytes) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst_step_y</td><td>dst_gx_stride_y * number of elements along Y processed per workitem(in bytes) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">dst_offset_first_element_in_bytes</td><td>The offset of the first element in the destination matrix </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="transpose_8cl_source.xhtml#l00145">145</a> of file <a class="el" href="transpose_8cl_source.xhtml">transpose.cl</a>.</p>

<p>References <a class="el" href="helpers_8h_source.xhtml#l00073">CONVERT_TO_IMAGE_STRUCT</a>, <a class="el" href="convolution3x3_8cl_source.xhtml#l00027">DATA_TYPE</a>, <a class="el" href="helpers_8h_source.xhtml#l00201">offset()</a>, and <a class="el" href="helpers_8h_source.xhtml#l00032">VEC_DATA_TYPE</a>.</p>
<div class="fragment"><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;{</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    uint x = get_global_id(0) * BLOCK_SIZE;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;    uint y = get_global_id(1) * BLOCK_SIZE;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    <span class="comment">// Compute source address</span></div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> src = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(src);</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    <span class="comment">// Load the NxN block at (x, y)</span></div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(<a class="code" href="convolution3x3_8cl.xhtml#afb8c72ce35c4a1f4a2588d6573e54aa1">DATA_TYPE</a>, BLOCK_SIZE)</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    u0 = VLOAD(0, (__global <a class="code" href="convolution3x3_8cl.xhtml#afb8c72ce35c4a1f4a2588d6573e54aa1">DATA_TYPE</a> *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 0)));</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(<a class="code" href="convolution3x3_8cl.xhtml#afb8c72ce35c4a1f4a2588d6573e54aa1">DATA_TYPE</a>, BLOCK_SIZE)</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    u1 = VLOAD(0, (__global DATA_TYPE *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 1)));</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(DATA_TYPE, BLOCK_SIZE)</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    u2 = VLOAD(0, (__global DATA_TYPE *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 2)));</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(DATA_TYPE, BLOCK_SIZE)</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    u3 = VLOAD(0, (__global DATA_TYPE *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 3)));</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;<span class="preprocessor">#if BLOCK_SIZE &gt; 4</span></div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(DATA_TYPE, BLOCK_SIZE)</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    u4 = VLOAD(0, (__global DATA_TYPE *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 4)));</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(DATA_TYPE, BLOCK_SIZE)</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    u5 = VLOAD(0, (__global DATA_TYPE *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 5)));</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(DATA_TYPE, BLOCK_SIZE)</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    u6 = VLOAD(0, (__global DATA_TYPE *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 6)));</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(DATA_TYPE, BLOCK_SIZE)</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    u7 = VLOAD(0, (__global DATA_TYPE *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 7)));</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="preprocessor">#if BLOCK_SIZE == 16</span></div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(DATA_TYPE, BLOCK_SIZE)</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    u8 = VLOAD(0, (__global DATA_TYPE *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 8)));</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(DATA_TYPE, BLOCK_SIZE)</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;    u9 = VLOAD(0, (__global DATA_TYPE *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 9)));</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(DATA_TYPE, BLOCK_SIZE)</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    u10 = VLOAD(0, (__global DATA_TYPE *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 10)));</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(DATA_TYPE, BLOCK_SIZE)</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    u11 = VLOAD(0, (__global DATA_TYPE *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 11)));</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(DATA_TYPE, BLOCK_SIZE)</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    u12 = VLOAD(0, (__global DATA_TYPE *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 12)));</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(DATA_TYPE, BLOCK_SIZE)</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    u13 = VLOAD(0, (__global DATA_TYPE *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 13)));</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(DATA_TYPE, BLOCK_SIZE)</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    u14 = VLOAD(0, (__global DATA_TYPE *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 14)));</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    <a class="code" href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a>(DATA_TYPE, BLOCK_SIZE)</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    u15 = VLOAD(0, (__global DATA_TYPE *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 15)));</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* BLOCK_SIZE == 16 */</span><span class="preprocessor"></span></div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* BLOCK_SIZE &gt; 4 */</span><span class="preprocessor"></span></div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    <span class="comment">// Transpose the block</span></div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    TRANSPOSE();</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    <span class="comment">// Store the block at (y, x)</span></div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;    uint dst_offset_in_bytes = y * DATA_TYPE_IN_BYTES + x * dst_stride_y + dst_offset_first_element_in_bytes;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    VSTORE(u0, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 0 * dst_stride_y));</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    VSTORE(u1, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 1 * dst_stride_y));</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    VSTORE(u2, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 2 * dst_stride_y));</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    VSTORE(u3, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 3 * dst_stride_y));</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;<span class="preprocessor">#if BLOCK_SIZE &gt; 4</span></div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    VSTORE(u4, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 4 * dst_stride_y));</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    VSTORE(u5, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 5 * dst_stride_y));</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    VSTORE(u6, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 6 * dst_stride_y));</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    VSTORE(u7, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 7 * dst_stride_y));</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;<span class="preprocessor">#if BLOCK_SIZE == 16</span></div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;    VSTORE(u8, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 8 * dst_stride_y));</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    VSTORE(u9, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 9 * dst_stride_y));</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    VSTORE(u10, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 10 * dst_stride_y));</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    VSTORE(u11, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 11 * dst_stride_y));</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    VSTORE(u12, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 12 * dst_stride_y));</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    VSTORE(u13, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 13 * dst_stride_y));</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    VSTORE(u14, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 14 * dst_stride_y));</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    VSTORE(u15, 0, (__global DATA_TYPE *)(dst_ptr + dst_offset_in_bytes + 15 * dst_stride_y));</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* BLOCK_SIZE == 16 */</span><span class="preprocessor"></span></div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* BLOCK_SIZE &gt; 4 */</span><span class="preprocessor"></span></div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;}</div><div class="ttc" id="convolution3x3_8cl_xhtml_afb8c72ce35c4a1f4a2588d6573e54aa1"><div class="ttname"><a href="convolution3x3_8cl.xhtml#afb8c72ce35c4a1f4a2588d6573e54aa1">DATA_TYPE</a></div><div class="ttdeci">#define DATA_TYPE</div><div class="ttdef"><b>Definition:</b> <a href="convolution3x3_8cl_source.xhtml#l00027">convolution3x3.cl:27</a></div></div>
<div class="ttc" id="helpers_8h_xhtml_a009469e4d9b8fce3b6d5e97d2077827d"><div class="ttname"><a href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a></div><div class="ttdeci">__global uchar * offset(const Image *img, int x, int y)</div><div class="ttdoc">Get the pointer position of a Image. </div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00201">helpers.h:201</a></div></div>
<div class="ttc" id="helpers_8h_xhtml_aebe814363556c244be043b13e7969197"><div class="ttname"><a href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a></div><div class="ttdeci">#define CONVERT_TO_IMAGE_STRUCT(name)</div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00073">helpers.h:73</a></div></div>
<div class="ttc" id="helpers_8h_xhtml_a36f754c05b6fddf6df0d8d0a74f8159f"><div class="ttname"><a href="helpers_8h.xhtml#a36f754c05b6fddf6df0d8d0a74f8159f">VEC_DATA_TYPE</a></div><div class="ttdeci">#define VEC_DATA_TYPE(type, size)</div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00032">helpers.h:32</a></div></div>
<div class="ttc" id="struct_image_xhtml"><div class="ttname"><a href="struct_image.xhtml">Image</a></div><div class="ttdoc">Structure to hold Image information. </div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00095">helpers.h:95</a></div></div>
</div><!-- fragment -->
</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.xhtml">src</a></li><li class="navelem"><a class="el" href="dir_aebb8dcc11953d78e620bbef0b9e2183.xhtml">core</a></li><li class="navelem"><a class="el" href="dir_8c278f79c760e5c5fbd911f9870614c1.xhtml">CL</a></li><li class="navelem"><a class="el" href="dir_25885286e9dad4fa105b7b25a8031bbf.xhtml">cl_kernels</a></li><li class="navelem"><a class="el" href="transpose_8cl.xhtml">transpose.cl</a></li>
    <li class="footer">Generated on Wed Apr 12 2017 17:30:09 for ARM Compute Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
